"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.traverse = void 0;
const typescript_1 = __importDefault(require("typescript"));
const traverse = (create) => (context) => (rootNode) => {
    const visit = (node) => {
        if (!typescript_1.default.isSourceFile(node)) {
            return node;
        }
        return context.factory.updateSourceFile(node, create(context), node.isDeclarationFile, node.referencedFiles, node.typeReferenceDirectives, node.hasNoDefaultLib, node.libReferenceDirectives);
    };
    return typescript_1.default.visitNode(rootNode, visit);
};
exports.traverse = traverse;
//# sourceMappingURL=traverse.js.map