"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ComponentChild = exports.Components = exports.escapeText = exports.isAvailableVariableName = exports.responseContentType = exports.requestContentType = exports.responseName = exports.argumentParamsTypeDeclaration = exports.requestBodyName = exports.parameterName = void 0;
const parameterName = (operationId) => `Parameter$${operationId}`;
exports.parameterName = parameterName;
const requestBodyName = (operationId) => `RequestBody$${operationId}`;
exports.requestBodyName = requestBodyName;
const argumentParamsTypeDeclaration = (operationId) => `Params$${operationId}`;
exports.argumentParamsTypeDeclaration = argumentParamsTypeDeclaration;
const responseName = (operationId, statusCode) => `Response$${operationId}$Status$${statusCode}`;
exports.responseName = responseName;
const requestContentType = (operationId) => `RequestContentType$${operationId}`;
exports.requestContentType = requestContentType;
const responseContentType = (operationId) => `ResponseContentType$${operationId}`;
exports.responseContentType = responseContentType;
const isAvailableVariableName = (text) => {
    return /^[A-Za-z_\s]+$/.test(text);
};
exports.isAvailableVariableName = isAvailableVariableName;
const escapeText = (text) => {
    if (exports.isAvailableVariableName(text)) {
        return text;
    }
    return `"${text}"`;
};
exports.escapeText = escapeText;
exports.Components = {
    Schemas: "Schemas",
    Parameters: "Parameters",
    Headers: "Headers",
    SecuritySchemas: "SecuritySchemas",
    PathItems: "PathItems",
    RequestBodies: "RequestBodies",
    Responses: "Responses",
};
exports.ComponentChild = {
    Header: "Header",
    Content: "Content",
    Response: "Response",
};
//# sourceMappingURL=Name.js.map