"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateInterface = exports.generatePropertySignatures = exports.generatePropertySignature = exports.generateTypeNode = void 0;
const Guard = __importStar(require("../Guard"));
const Name = __importStar(require("../Name"));
const ToTypeNode = __importStar(require("../toTypeNode"));
const Reference = __importStar(require("./Reference"));
const generateTypeNode = (entryPoint, currentPoint, factory, name, header, context) => {
    return factory.TypeAliasDeclaration.create({
        export: true,
        name,
        type: ToTypeNode.convert(entryPoint, currentPoint, factory, header.schema || { type: "null" }, context),
    });
};
exports.generateTypeNode = generateTypeNode;
const generatePropertySignature = (entryPoint, currentPoint, factory, name, header, context) => {
    if (Guard.isReference(header)) {
        const reference = Reference.generate(entryPoint, currentPoint, header);
        if (reference.type === "local") {
            context.setReferenceHandler(reference);
            return factory.PropertySignature.create({
                name,
                optional: false,
                type: factory.TypeReferenceNode.create({
                    name: context.getReferenceName(currentPoint, reference.path),
                }),
            });
        }
        return factory.PropertySignature.create({
            name,
            optional: false,
            type: factory.TypeReferenceNode.create({
                name: context.getReferenceName(currentPoint, reference.path),
            }),
        });
    }
    return factory.PropertySignature.create({
        name: Name.escapeText(name),
        optional: false,
        type: ToTypeNode.convert(entryPoint, currentPoint, factory, header.schema || { type: "null" }, context),
    });
};
exports.generatePropertySignature = generatePropertySignature;
const generatePropertySignatures = (entryPoint, currentPoint, factory, headers, context) => {
    return Object.entries(headers).map(([headerName, header]) => {
        return exports.generatePropertySignature(entryPoint, currentPoint, factory, headerName, header, context);
    });
};
exports.generatePropertySignatures = generatePropertySignatures;
const generateInterface = (entryPoint, currentPoint, factory, name, headers, context) => {
    return factory.InterfaceDeclaration.create({
        export: true,
        name,
        comment: `@see https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.1.0.md#headerObject`,
        members: exports.generatePropertySignatures(entryPoint, currentPoint, factory, headers, context),
    });
};
exports.generateInterface = generateInterface;
//# sourceMappingURL=Header.js.map