"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateInterface = exports.generatePropertySignatures = exports.generatePropertySignature = void 0;
const Name = __importStar(require("../Name"));
const ToTypeNode = __importStar(require("../toTypeNode"));
const generatePropertySignature = (entryPoint, currentPoint, factory, protocol, schema, context) => {
    return factory.PropertySignature.create({
        name: Name.escapeText(protocol),
        optional: false,
        type: ToTypeNode.convert(entryPoint, currentPoint, factory, schema, context),
    });
};
exports.generatePropertySignature = generatePropertySignature;
const generatePropertySignatures = (entryPoint, currentPoint, factory, content, context) => {
    return Object.entries(content).reduce((previous, [protocol, mediaType]) => {
        if (!mediaType.schema) {
            return previous;
        }
        return previous.concat(exports.generatePropertySignature(entryPoint, currentPoint, factory, protocol, mediaType.schema, context));
    }, []);
};
exports.generatePropertySignatures = generatePropertySignatures;
const generateInterface = (entryPoint, currentPoint, factory, name, content, context) => {
    return factory.InterfaceDeclaration.create({
        export: true,
        name,
        members: exports.generatePropertySignatures(entryPoint, currentPoint, factory, content, context),
        comment: `@see https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.1.0.md#mediaTypeObject`,
    });
};
exports.generateInterface = generateInterface;
//# sourceMappingURL=MediaType.js.map