"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.set = exports.get = void 0;
const Def = __importStar(require("./Definition"));
const SLASH_DELIMITER = "/";
const get = (obj, type, path, delimiter = SLASH_DELIMITER) => {
    const pathArray = path.split(delimiter);
    const firstKey = pathArray[0];
    const nextPath = pathArray.slice(1, pathArray.length);
    const isFinal = nextPath.length === 0;
    const nextType = nextPath.length >= 1 ? "namespace" : "interface";
    const key = Def.generateKey(isFinal ? type : nextType, firstKey);
    const target = obj[key];
    if (!target) {
        return;
    }
    if (target.type === "namespace") {
        if (isFinal) {
            return target;
        }
        else {
            return exports.get(target.statements, type, nextPath.join(delimiter), delimiter);
        }
    }
    if (target.type === "interface") {
        return target;
    }
    if (target.type === "typeAlias") {
        return target;
    }
    return undefined;
};
exports.get = get;
const set = (obj, path, statement, createNamespace, delimiter = SLASH_DELIMITER) => {
    const [firstPath, ...pathArray] = path.split(delimiter);
    if (!firstPath) {
        return obj;
    }
    const isBottom = pathArray.length === 0;
    const childObj = exports.get(obj, "namespace", firstPath, delimiter);
    const target = childObj ? childObj : createNamespace(firstPath);
    target.statements = exports.set(target.statements, pathArray.join(delimiter), statement, createNamespace, delimiter);
    const key = Def.generateKey(isBottom ? statement.type : target.type, firstPath);
    obj[key] = isBottom ? statement : target;
    return obj;
};
exports.set = set;
//# sourceMappingURL=PropAccess.js.map