"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.maskValue = void 0;
const Def = __importStar(require("./Definition"));
const maskingNamespace = (namespaceStatement) => {
    const statements = Object.entries(namespaceStatement.statements).reduce((newStatement, [key, statement]) => {
        if (statement) {
            newStatement[key] = maskingStatement(statement);
        }
        return newStatement;
    }, {});
    return {
        type: "namespace",
        name: namespaceStatement.name,
        value: namespaceStatement.value.name.text,
        statements,
    };
};
const maskingInterface = (statement) => {
    return {
        type: "interface",
        name: statement.name,
        value: statement.value.name.text,
    };
};
const maskingTypeAlias = (statement) => {
    return {
        type: "typeAlias",
        name: statement.name,
        value: statement.value.name.text,
    };
};
const maskingStatement = (statement) => {
    if (statement.type === "interface") {
        return maskingInterface(statement);
    }
    if (statement.type === "typeAlias") {
        return maskingTypeAlias(statement);
    }
    return maskingNamespace(statement);
};
const maskValue = (state) => {
    const kinds = ["namespace", "typeAlias", "interface"];
    return Def.componentNames.reduce((newState, componentName) => {
        kinds.forEach(kind => {
            const key = Def.generateKey(kind, componentName);
            const component = state.components[key];
            if (!component) {
                return;
            }
            newState.components[key] = maskingStatement(component);
        });
        return newState;
    }, state);
};
exports.maskValue = maskValue;
//# sourceMappingURL=masking.js.map