"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fileSystem = void 0;
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
const dot_prop_1 = __importDefault(require("dot-prop"));
const yaml = __importStar(require("js-yaml"));
const Exception_1 = require("../Exception");
const create = () => {
    const FRAGMENT = "#/";
    const loadJsonOrYaml = (filename) => {
        const ext = path.extname(filename);
        const data = fs.readFileSync(filename, { encoding: "utf-8" });
        switch (ext) {
            case ".json":
                return JSON.parse(data);
            case ".yml":
            case ".yaml":
                return yaml.load(data);
            default:
                throw new Exception_1.UnSupportError(`Not support file: ${filename}`);
        }
    };
    return {
        existSync: (entryPoint) => {
            return !!(fs.existsSync(entryPoint) && fs.statSync(entryPoint).isFile());
        },
        loadJsonOrYaml: (entryPoint) => {
            const hasFragment = new RegExp(FRAGMENT).test(entryPoint);
            if (hasFragment) {
                const [filename, fragment] = entryPoint.split(FRAGMENT);
                const data = loadJsonOrYaml(filename);
                return dot_prop_1.default.get(data, fragment.replace(/\//g, "."));
            }
            return loadJsonOrYaml(entryPoint);
        },
    };
};
exports.fileSystem = create();
//# sourceMappingURL=index.js.map