export const isReference = (data) => {
    if (typeof data !== "object" || data === null) {
        return false;
    }
    return typeof data.$ref === "string";
};
export const isUnSupportSchema = (schema) => {
    return Array.isArray(schema.type);
};
export const isObjectSchema = (schema) => {
    return schema.type === "object";
};
export const isArraySchema = (schema) => {
    return schema.type === "array";
};
export const isPrimitiveSchema = (schema) => {
    if (typeof schema.type !== "string") {
        return false;
    }
    if (schema.type === "object") {
        return false;
    }
    if (schema.type === "array") {
        return false;
    }
    return true;
};
export const isNumberArray = (list) => {
    return !list.some(item => typeof item !== "number");
};
export const isStringArray = (list) => {
    return !list.some(item => typeof item !== "string");
};
export const isObjectSchemaWithAdditionalProperties = (schema) => {
    return !!schema.additionalProperties;
};
export const isOneOfSchema = (schema) => {
    return !!schema.oneOf && typeof schema.oneOf !== "boolean" && Array.isArray(schema.oneOf);
};
export const isAllOfSchema = (schema) => {
    return !!schema.allOf && typeof schema.allOf !== "boolean" && Array.isArray(schema.allOf);
};
export const isAnyOfSchema = (schema) => {
    return !!schema.anyOf && typeof schema.anyOf !== "boolean" && Array.isArray(schema.anyOf);
};
export const isComponentName = (name) => {
    return ["schemas", "headers", "responses", "parameters", "requestBodies", "securitySchemes", "pathItems"].includes(name);
};
//# sourceMappingURL=Guard.js.map