import * as Name from "../Name";
import * as ToTypeNode from "../toTypeNode";
export const generatePropertySignature = (entryPoint, currentPoint, factory, protocol, schema, context) => {
    return factory.PropertySignature.create({
        name: Name.escapeText(protocol),
        optional: false,
        type: ToTypeNode.convert(entryPoint, currentPoint, factory, schema, context),
    });
};
export const generatePropertySignatures = (entryPoint, currentPoint, factory, content, context) => {
    return Object.entries(content).reduce((previous, [protocol, mediaType]) => {
        if (!mediaType.schema) {
            return previous;
        }
        return previous.concat(generatePropertySignature(entryPoint, currentPoint, factory, protocol, mediaType.schema, context));
    }, []);
};
export const generateInterface = (entryPoint, currentPoint, factory, name, content, context) => {
    return factory.InterfaceDeclaration.create({
        export: true,
        name,
        members: generatePropertySignatures(entryPoint, currentPoint, factory, content, context),
        comment: `@see https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.1.0.md#mediaTypeObject`,
    });
};
//# sourceMappingURL=MediaType.js.map