import * as MediaType from "./MediaType";
export const generateInterface = (entryPoint, currentPoint, factory, name, requestBody, context) => {
    const contentSignatures = MediaType.generatePropertySignatures(entryPoint, currentPoint, factory, requestBody.content || {}, context);
    return factory.InterfaceDeclaration.create({
        export: true,
        name,
        members: contentSignatures,
        comment: `@see https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.1.0.md#requestBodyObject`,
    });
};
export const generateNamespace = (entryPoint, currentPoint, store, factory, parentName, name, requestBody, context) => {
    const basePath = `${parentName}/${name}`;
    store.addStatement(basePath, {
        type: "namespace",
        name,
        value: factory.Namespace.create({
            export: true,
            name,
            comment: requestBody.description,
            statements: [generateInterface(entryPoint, currentPoint, factory, "Content", requestBody, context)],
        }),
        statements: {},
    });
};
//# sourceMappingURL=RequestBody.js.map