import * as PathItem from "../components/PathItem";
import * as Reference from "../components/Reference";
import * as Guard from "../Guard";
export const generateStatements = (entryPoint, currentPoint, store, factory, paths, context) => {
    const statements = [];
    Object.entries(paths).forEach(([requestUri, pathItem]) => {
        if (!requestUri.startsWith("/")) {
            throw new Error(`Not start slash: ${requestUri}`);
        }
        if (Guard.isReference(pathItem)) {
            const reference = Reference.generate(entryPoint, currentPoint, pathItem);
            if (reference.type === "local") {
                statements.push(PathItem.generateStatements(entryPoint, currentPoint, store, factory, requestUri, store.getPathItem(reference.path), context));
            }
            else {
                statements.push(PathItem.generateStatements(entryPoint, reference.referencePoint, store, factory, requestUri, reference.data, context));
            }
        }
        else {
            statements.push(PathItem.generateStatements(entryPoint, currentPoint, store, factory, requestUri, pathItem, context));
        }
    });
    store.addAdditionalStatement(statements.flat());
};
//# sourceMappingURL=index.js.map