import * as Def from "./Definition";
const SLASH_DELIMITER = "/";
export const get = (obj, type, path, delimiter = SLASH_DELIMITER) => {
    const pathArray = path.split(delimiter);
    const firstKey = pathArray[0];
    const nextPath = pathArray.slice(1, pathArray.length);
    const isFinal = nextPath.length === 0;
    const nextType = nextPath.length >= 1 ? "namespace" : "interface";
    const key = Def.generateKey(isFinal ? type : nextType, firstKey);
    const target = obj[key];
    if (!target) {
        return;
    }
    if (target.type === "namespace") {
        if (isFinal) {
            return target;
        }
        else {
            return get(target.statements, type, nextPath.join(delimiter), delimiter);
        }
    }
    if (target.type === "interface") {
        return target;
    }
    if (target.type === "typeAlias") {
        return target;
    }
    return undefined;
};
export const set = (obj, path, statement, createNamespace, delimiter = SLASH_DELIMITER) => {
    const [firstPath, ...pathArray] = path.split(delimiter);
    if (!firstPath) {
        return obj;
    }
    const isBottom = pathArray.length === 0;
    const childObj = get(obj, "namespace", firstPath, delimiter);
    const target = childObj ? childObj : createNamespace(firstPath);
    target.statements = set(target.statements, pathArray.join(delimiter), statement, createNamespace, delimiter);
    const key = Def.generateKey(isBottom ? statement.type : target.type, firstPath);
    obj[key] = isBottom ? statement : target;
    return obj;
};
//# sourceMappingURL=PropAccess.js.map