import ts from "typescript";
import * as BinaryExpression from "./BinaryExpression";
import * as Block from "./Block";
import * as CallExpression from "./CallExpression";
import * as ClassDeclaration from "./ClassDeclaration";
import * as ConstructorDeclaration from "./ConstructorDeclaration";
import * as ElementAccessExpression from "./ElementAccessExpression";
import * as FunctionTypeNode from "./FunctionTypeNode";
import * as Identifier from "./Identifier";
import * as IndexedAccessTypeNode from "./IndexedAccessTypeNode";
import * as IndexSignatureDeclaration from "./IndexSignatureDeclaration";
import * as InterfaceDeclaration from "./InterfaceDeclaration";
import * as IntersectionTypeNode from "./IntersectionTypeNode";
import * as LiteralTypeNode from "./LiteralTypeNode";
import * as MethodDeclaration from "./MethodDeclaration";
import * as Namespace from "./Namespace";
import * as NoSubstitutionTemplateLiteral from "./NoSubstitutionTemplateLiteral";
import * as ObjectLiteralExpression from "./ObjectLiteralExpression";
import * as ParameterDeclaration from "./ParameterDeclaration";
import * as PropertyAccessExpression from "./PropertyAccessExpression";
import * as PropertyAssignment from "./PropertyAssignment";
import * as PropertySignature from "./PropertySignature";
import * as ReturnStatement from "./ReturnStatement";
import * as StringLiteral from "./StringLiteral";
import * as TemplateExpression from "./TemplateExpression";
import * as TemplateHead from "./TemplateHead";
import * as TemplateMiddle from "./TemplateMiddle";
import * as TemplateSpan from "./TemplateSpan";
import * as TemplateTail from "./TemplateTail";
import * as TypeAliasDeclaration from "./TypeAliasDeclaration";
import * as TypeLiteralNode from "./TypeLiteralNode";
import * as TypeNode from "./TypeNode";
import * as TypeOperatorNode from "./TypeOperatorNode";
import * as TypeParameterDeclaration from "./TypeParameterDeclaration";
import * as TypeReferenceNode from "./TypeReferenceNode";
import * as UnionTypeNode from "./UnionTypeNode";
import * as VariableDeclaration from "./VariableDeclaration";
import * as VariableDeclarationList from "./VariableDeclarationList";
import * as VariableStatement from "./VariableStatement";
export interface Type {
    Block: Block.Factory;
    ClassDeclaration: ClassDeclaration.Factory;
    InterfaceDeclaration: InterfaceDeclaration.Factory;
    ParameterDeclaration: ParameterDeclaration.Factory;
    IndexedAccessTypeNode: IndexedAccessTypeNode.Factory;
    MethodDeclaration: MethodDeclaration.Factory;
    TypeOperatorNode: TypeOperatorNode.Factory;
    Namespace: Namespace.Factory;
    PropertySignature: PropertySignature.Factory;
    TypeAliasDeclaration: TypeAliasDeclaration.Factory;
    TypeNode: TypeNode.Factory;
    LiteralTypeNode: LiteralTypeNode.Factory;
    IndexSignatureDeclaration: IndexSignatureDeclaration.Factory;
    UnionTypeNode: UnionTypeNode.Factory;
    IntersectionTypeNode: IntersectionTypeNode.Factory;
    TypeReferenceNode: TypeReferenceNode.Factory;
    TypeParameterDeclaration: TypeParameterDeclaration.Factory;
    ConstructorDeclaration: ConstructorDeclaration.Factory;
    ReturnStatement: ReturnStatement.Factory;
    VariableDeclaration: VariableDeclaration.Factory;
    VariableDeclarationList: VariableDeclarationList.Factory;
    VariableStatement: VariableStatement.Factory;
    BinaryExpression: BinaryExpression.Factory;
    PropertyAccessExpression: PropertyAccessExpression.Factory;
    NoSubstitutionTemplateLiteral: NoSubstitutionTemplateLiteral.Factory;
    TemplateSpan: TemplateSpan.Factory;
    TemplateExpression: TemplateExpression.Factory;
    TemplateHead: TemplateHead.Factory;
    TemplateMiddle: TemplateMiddle.Factory;
    TemplateTail: TemplateTail.Factory;
    Identifier: Identifier.Factory;
    PropertyAssignment: PropertyAssignment.Factory;
    ObjectLiteralExpression: ObjectLiteralExpression.Factory;
    ElementAccessExpression: ElementAccessExpression.Factory;
    CallExpression: CallExpression.Factory;
    StringLiteral: StringLiteral.Factory;
    FunctionTypeNode: FunctionTypeNode.Factory;
    TypeLiteralNode: TypeLiteralNode.Factory;
}
export declare const create: (context: ts.TransformationContext) => Type;
