import ts from "typescript";
import { Factory } from "../../../CodeGenerator";
import { Store } from "../store";
import * as ToTypeNode from "../toTypeNode";
import { ArraySchema, ObjectSchema, OpenApi, PrimitiveSchema } from "../types";
export declare const generatePropertySignatures: (entryPoint: string, currentPoint: string, factory: Factory.Type, schema: ObjectSchema, context: ToTypeNode.Context) => ts.PropertySignature[];
export declare const generateInterface: (entryPoint: string, currentPoint: string, factory: Factory.Type, name: string, schema: ObjectSchema, context: ToTypeNode.Context) => ts.InterfaceDeclaration;
export declare const generateArrayTypeAlias: (entryPoint: string, currentPoint: string, factory: Factory.Type, name: string, schema: ArraySchema, context: ToTypeNode.Context) => ts.TypeAliasDeclaration;
export declare const generateTypeAlias: (entryPoint: string, currentPoint: string, factory: Factory.Type, name: string, schema: PrimitiveSchema) => ts.TypeAliasDeclaration;
export declare const generateMultiTypeAlias: (entryPoint: string, currentPoint: string, factory: Factory.Type, name: string, schemas: OpenApi.Schema[], context: ToTypeNode.Context, multiType: "oneOf" | "allOf" | "anyOf") => ts.TypeAliasDeclaration;
export declare const addSchema: (entryPoint: string, currentPoint: string, store: Store.Type, factory: Factory.Type, targetPoint: string, declarationName: string, schema: OpenApi.Schema | undefined, context: ToTypeNode.Context) => void;
