import ts from "typescript";
import { OpenApi } from "../types";
import * as Def from "./Definition";
export declare type A = ts.ModuleDeclaration;
export declare type B = ts.InterfaceDeclaration;
export declare type C = ts.TypeAliasDeclaration;
export interface OperationState {
    requestUri: string;
    httpMethod: string;
    parameterName?: string;
    requestBodyName?: string;
}
export interface Type {
    document: OpenApi.Document;
    components: Def.StatementMap<A, B, C>;
    paths: {
        [pathString: string]: {
            ref: string;
        };
    };
    additionalStatements: ts.Statement[];
    operations: {
        [operationId: string]: OperationState;
    };
}
export declare const createDefaultOperationState: (httpMethod: string, requestUri: string, state: Partial<OperationState>) => OperationState;
export declare const createDefaultState: (rootDocument: OpenApi.Document) => Type;
