import ts from "typescript";
import { Factory } from "../../../CodeGenerator";
import { OpenApi } from "../types";
import * as Def from "./Definition";
import * as Operation from "./Operation";
import * as State from "./State";
export declare type A = State.A;
export declare type B = State.B;
export declare type C = State.C;
export interface Type {
    addComponent: (componentName: Def.ComponentName, statement: Def.Statement<A, B, C>) => void;
    /**
     * @params path: "components/headers/hoge"
     */
    addStatement: (path: string, statement: Def.Statement<A, B, C>) => void;
    getStatement: (path: string, types: Def.Statement<A, B, C>["type"]) => Def.Statement<A, B, C> | undefined;
    /**
     * @params path: "components/headers/hoge"
     */
    hasStatement: (path: string, types: Def.Statement<A, B, C>["type"][]) => boolean;
    addAdditionalStatement: (statements: ts.Statement[]) => void;
    getRootStatements: () => ts.Statement[];
    updateOperationState: (httpMethod: string, requestUri: string, operationId: string, state: Partial<State.OperationState>) => void;
    getOperationState: (operationId: string) => State.OperationState;
    dump: (filename: string) => void;
    dumpOperationState: (filename: string) => void;
    getNoReferenceOperationState: () => Operation.State;
    getPathItem: (localPath: string) => OpenApi.PathItem;
}
export declare const create: (factory: Factory.Type, rootDocument: OpenApi.Document) => Type;
