import ts from "typescript";
import { Factory } from "../../CodeGenerator";
import * as Reference from "./components/Reference";
import { OpenApi } from "./types";
import { ObjectSchemaWithAdditionalProperties } from "./types";
export interface Context {
    setReferenceHandler: (reference: Reference.Type<OpenApi.Schema | OpenApi.JSONSchemaDefinition>) => void;
    getReferenceName: (currentPoint: string, referencePath: string) => string;
}
export declare type Convert = (entryPoint: string, currentPoint: string, factory: Factory.Type, schema: OpenApi.Schema | OpenApi.Reference | OpenApi.JSONSchemaDefinition, setReference: Context, option?: Option) => ts.TypeNode;
export interface Option {
    parent?: any;
}
export declare const generateMultiTypeNode: (entryPoint: string, currentPoint: string, factory: Factory.Type, schemas: OpenApi.JSONSchema[], setReference: Context, convert: Convert, multiType: "oneOf" | "allOf" | "anyOf") => ts.TypeNode;
export declare const convert: Convert;
export declare const convertAdditionalProperties: (entryPoint: string, currentPoint: string, factory: Factory.Type, schema: ObjectSchemaWithAdditionalProperties, setReference: Context) => ts.IndexSignatureDeclaration;
