import * as OpenApi from "./OpenApiSchemaV3";
export declare type PickedParameter = Pick<OpenApi.Parameter, "name" | "in" | "required" | "style" | "explode">;
export interface CodeGeneratorParams {
    operationId: string;
    httpMethod: string;
    rawRequestUri: string;
    functionName: string;
    comment: string | undefined;
    deprecated: boolean;
    argumentParamsTypeDeclaration: string;
    pickedParameters: PickedParameter[];
    requestContentTypes: string[];
    requestFirstContentType: string | undefined;
    has2OrMoreRequestContentTypes: boolean;
    responseSuccessNames: string[];
    responseFirstSuccessName: string | undefined;
    has2OrMoreSuccessNames: boolean;
    successResponseContentTypes: string[];
    successResponseFirstContentType: string | undefined;
    has2OrMoreSuccessResponseContentTypes: boolean;
    hasAdditionalHeaders: boolean;
    hasQueryParameters: boolean;
    hasParameter: boolean;
    hasRequestBody: boolean;
}
