import ts from "typescript";
import { Factory } from "../CodeGenerator";
import { CodeGeneratorParams } from "../Converter/v3";
/**
 * export type RequestContentType${operationId} = keyof RequestBody${operationId};
 */
export declare const createRequestContentTypeReference: (factory: Factory.Type, { operationId }: CodeGeneratorParams) => ts.TypeAliasDeclaration;
/**
 * export type ResponseContentType${operationId} = keyof Response${operationId}$Status$200;
 * export type ResponseContentType${operationId} = keyof Response${operationId}$Status$200 | keyof Response${operationId}$Status$203;
 */
export declare const createResponseContentTypeReference: (factory: Factory.Type, params: CodeGeneratorParams) => ts.TypeAliasDeclaration;
/**
 * Function Template
 *
 * export interface {name}<T extends keyof {requestBodyName}> {
 *   parameter: {parameterName};
 *   requestBody: {requestBodyName}[T];
 * }
 */
export declare const create: (factory: Factory.Type, params: CodeGeneratorParams) => ts.InterfaceDeclaration | undefined;
